Target version: 1.2.0

Resolution: Fixed

Description

This feature request is based on forum's topic:
http://www.redmine.org/boards/2/topics/8609#message-8637

When running redmine as windows service, it's not guaranteed that users will have "svn" command available, especially on windows,
and setting up access to repository ends with this error message:
http://i49.tinypic.com/v309c3.png

In order to simplicify administration process, | propose to check if "svn" command if available when they save settings:
http://i49.tinypic.com/x5¢j08.png

If it's not, we have 2 options to ask user to make "svn" command available

1. Either by installing svn client on *nix

2. Or by installing svn client / server on windows and putting path to executable into PATH folder.
2.1. Maybe it's also good option to simply ask them path to svn executable on windows.

Also it's good point to note on this settings page that not all windows clients has svn.exe executable itself (for example, tortoisesvn
client has no svn executable), so you must recommend to install SVN server with standard svn.exe available and which supports
standard SVN commands (like tortoise svn does not) - as for me it will be just good tip for users that are not so familiar with servers,
services and clients terminology, and so you will improve gui considerably and make settings more easy to understand and more
user-friendly (while implementation is so simple).

p.s. | thinked about this issue because | lost 2 hours myself by setting up integration with svn over https and under windows server
2003.

Home makes sense,
Anton Andriyevskyy
x.meglio@gmail.com

Related issues:

Related to Redmine - Feature #7517: Configurable path of executable for scm a... Closed 2011-02-02
Related to Redmine - Defect #1604: Provide a more meaningful error when runni... Closed 2008-07-08
Related to Redmine - Feature #2799: Support for Bazaar's shared reposetories ... New 2009-02-21

Associated revisions

Revision 4821 - 2011-02-14 07:14 - Toshi MARUYAMA

scm: use shell quote for scm command at adapter level (#7517, #4273).
"C:\Program Files\TortoiseHg\hg.exe" can be used in config/configuration.yml.

In Ruby 1.9 10.popen, if cmd is an Array of String,
it will be used as the subprocess's argv bypassing a shell.

See http://www.ruby-doc.org/core/classes/IO.html

Revision 4822 - 2011-02-14 09:45 - Toshi MARUYAMA

scm: add scm command and version methods at repository models (#4273).
Revision 4825 - 2011-02-15 03:12 - Toshi MARUYAMA

scm: subversion: refactor getting svn version and add lib test (#4273).

Revision 4829 - 2011-02-15 06:58 - Toshi MARUYAMA
scm: git: add methods of getting git version and add unit lib test (#4273).

Revision 4831 - 2011-02-15 08:04 - Toshi MARUYAMA

scm: bazaar: add methods of getting bazaar version and add unit lib test (#4273).

Revision 4832 - 2011-02-15 09:04 - Toshi MARUYAMA

scm: cvs: add methods of getting cvs version and add unit lib test (#4273).
Revision 4881 - 2011-02-19 02:11 - Toshi MARUYAMA

scm: darcs: override client_available method (#4273).

| forgot it.

Revision 4882 - 2011-02-19 02:11 - Toshi MARUYAMA

scm: catch exception of getting command and version in model (#4273).

If command does not exist, Windows raises exception in shellout().
Linux does not raise exception.

Revision 4920 - 2011-02-22 09:05 - Toshi MARUYAMA
scm: Ruby 1.9 compatibility in getting scm version (#4273).

Revision 5360 - 2011-04-08 06:52 - Toshi MARUYAMA

scm: git: add client command tests at unit adapter test (#4273).

Revision 5361 - 2011-04-08 06:53 - Toshi MARUYAMA

scm: mercurial: add client command tests at unit adapter test (#4273).

Revision 5362 - 2011-04-08 07:42 - Toshi MARUYAMA

scm: git: add scm command tests at unit model test (#4273).

Revision 5363 - 2011-04-08 07:43 - Toshi MARUYAMA

scm: mercurial: add scm command tests at unit model test (#4273).

Revision 5364 - 2011-04-08 07:44 - Toshi MARUYAMA

scm: add filesystem available test at unit repository test (#4273).

Revision 5632 - 2011-05-04 09:49 - Toshi MARUYAMA

scm: add the feature of SCM command availability automatic check in administration panel (#4273).

Revision 5633 - 2011-05-04 09:49 - Toshi MARUYAMA

scm: add Japanese translation of the feature of SCM command availability automatic check in administration panel (#4273).

Revision 5634 - 2011-05-04 09:50 - Toshi MARUYAMA

scm: update locales of the feature of SCM command availability automatic check in administration panel (#4273).
Revision 5636 - 2011-05-04 10:26 - Toshi MARUYAMA
scm: subversion: set available version above 1.3 (#4273, #1604).

"--xml" options are introduced in 1.3.
http://subversion.apache.org/docs/release-notes/1.3.html

Revision 5726 - 2011-05-10 13:42 - Toshi MARUYAMA

scm: change i18n key name 'text_scm_version' to 'text_scm_command_version' in setting (#4273).
Revision 5727 - 2011-05-10 13:42 - Toshi MARUYAMA

scm: change separator between command and version ',' to '|' in setting (#4273).

Revision 5952 - 2011-05-29 12:54 - Toshi MARUYAMA

scm: show scm commands and versions on administration panel (#4273).

Revision 5953 - 2011-05-29 12:55 - Toshi MARUYAMA

scm: add Japanese i18n text of scm commands of config/configuration.yml in administrator panel (#4273).

Revision 5954 - 2011-05-29 12:56 - Toshi MARUYAMA

scm: update i18n text of scm commands of config/configuration.yml in administrator panel (#4273).

Revision 5955 - 2011-05-29 12:56 - Toshi MARUYAMA

scm: remove scm command and version on project setting (#4273).

show a message only if scm command is not available.

Revision 5956 - 2011-05-29 12:57 - Toshi MARUYAMA

scm: add Japanese i18n text that scm command is not available in project setting (#4273).

Revision 5957 - 2011-05-29 12:57 - Toshi MARUYAMA

scm: update i18n text that scm command is not available in project setting (#4273).

Revision 5960 - 2011-05-29 13:59 - Jean-Philippe Lang
Slight Ul changes (#4273).

Revision 6007 - 2011-06-08 13:19 - Toshi MARUYAMA

scm: add log message of config/configuration.yml if scm command raise Errno::ENOENT exception (#7517, #4273).

History

#1 - 2009-11-27 21:33 - Jean-Philippe Lang
- Priority changed from Low to Normal

- Target version set to 1.0.0 (RC)

That would help indeed.

#2 - 2010-02-23 18:12 - Asher Baker

(for example, tortoisesvn client has no svn executable), so you must recommend to install SVN server with standard svn.exe available and which
supports standard SVN commands (like tortoise svn does not)

Actually it is included, since TortoisSVN is only an interface for the command line client, and afaik also added to the path.
Other than that note, it's a great idea.

#3 - 2010-06-15 00:49 - Eric Davis
- Subject changed from "svn" availability automatic check in administration panel to SCM binary availability automatic check in administration panel

- Estimated time deleted (3.00 h)

#4 - 2010-06-30 03:07 - Eric Davis
- Target version deleted (1.0.0 (RC))

No patch uploaded and we are already well past the feature freeze for 1.0. Maybe in 1.1.

#5 - 2011-02-02 00:03 - Toshi MARUYAMA
- Category changed from Administration to SCM
#6 - 2011-02-09 11:35 - Toshi MARUYAMA

- Subject changed from SCM binary availability automatic check in administration panel to SCM command availability automatic check in

administration panel

- Assignee set to Toshi MARUYAMA

| change subject "binary" to "command".
Because Mercurial /usr/bin/hg is python script.

$ file /usr/bin/hg
/usr/bin/hg: a /usr/bin/python script text executable
$ file /usr/bin/bzr
/usr/bin/bzr: a /usr/bin/python script text executable

#7 - 2011-02-09 13:40 - Toshi MARUYAMA
- File info.png added

- File settings.png added

- % Done changed from 0 to 20

| start to implement this feature.

Information
Redmine 1.1.1.devel (50Lite)

Default administrator account changed
Attachments directory writable
Plugin assets directory writable

RMagick available (optional)

SCM

Name Command

Subversion

Darcs

Mercurial hg
CW5

Bazaar

Git

Filesystem

settings.png

#8 - 2011-02-18 14:03 - Toshi MARUYAMA
- File info-20110218.png added
- File scm-info-view.diff added

- % Done changed from 20 to 40

This is showing SCM info patch.
Please review.
Information Administration

Redmine 1.1.1.devel (SQLite)  Projects
- @ Users
Default administrator account changed ]
Attachments directory writable 4 &° Groups
Plugin assets directory writable L4 . Roles and permissions
RMagick available {optional) L 1]
.| Trackers
SCM
& Issue statuses
Name Command Version 2 Workflow
Subversi S\ 1.6.13 4
HbvErsen s Custom fields
Darcs darcs 2.4.4 L4
Mercurial /WEB-DOWN/hg-repo/hg-crew/hg 1.1.2 4 := Enumerations
CVs evs 1.12.13 4 4k Settings
Bazaar bzr 2.1.2 ' 4 _ o
) o ' %2 LDAP authentication
Git fusr/local/bin/git o
Filesystem 4 & Plugins

& Information

#9 - 2011-02-18 14:40 - Etienne Massip

Patch is based on "a" and "b" project paths, could you make it based on project root ?
At first glance, I'd say that code is neat and that "SCM" title should not be the same size than "Information".

Just a thought : SCM information could also be located in / linked to the Administration/Settings/Repositories/activated SCM list if you plan to change
its behavior so that the administrator immediately understand the reason he can't activate such scm.

I'll test it later.

#10 - 2011-02-18 14:55 - Toshi MARUYAMA

- File scm-info-view-select.diff added

Thank you for reviewing.

This is select list patch.

#11 - 2011-02-18 15:26 - Etienne Massip
Got a HTTP 500 rendering admin/info :

SCM command failed, make sure that your SCM binary (eg. svn) is in PATH (...): "darcs" --version
with: No such file or directory - "darcs" --version
Redmine: :Scm: :Adapters::CommandFailed (No such file or directory - "darcs" --version):

lib/redmine/scm/adapters/abstract_adapter.rb:211:in “shellout'
lib/redmine/scm/adapters/darcs_adapter.rb:49:in ‘darcs_binary_version_from_command_line'
lib/redmine/scm/adapters/darcs_adapter.rb:42:in ‘darcs_binary_version'
lib/redmine/scm/adapters/darcs_adapter.rb:38:in ‘client_version'
lib/redmine/scm/adapters/abstract_adapter.rb:41:in “client_version_string'
app/models/repository.rb:225:in "~ scm_version_string'
app/controllers/admin_controller.rb:90:in “info'
app/controllers/admin_controller.rb:86:in “each'
app/controllers/admin_controller.rb:86:in “info'

The only SCM installed is Subversion (and FS, of course).

#12 - 2011-02-18 15:28 - Etienne Massip
Toshi MARUYAMA wrote:

Thank you for reviewing.

This is select list patch.
Can't you just disable the checkboxes ?
#13 - 2011-02-18 15:56 - Toshi MARUYAMA
Etienne Massip wrote:
Toshi MARUYAMA wrote:
Thank you for reviewing.

This is select list patch.

Can't you just disable the checkboxes ?

I 'am not good at HTML coding. Could you try?
#14 - 2011-02-18 15:58 - Toshi MARUYAMA
Etienne Massip wrote:
Got a HTTP 500 rendering admin/info :
[--]
The only SCM installed is Subversion (and FS, of course).

Japan is midnight.
I will fix tomorrow.

#15 - 2011-02-18 16:27 - Etienne Massip
Good night then =)
Sorry, | was mistaken : | thought the 2nd patch was for the Administration/Settings/Repositories/activated SCM checkboxes list.

Handling checkboxes state in this list would require some changes in setting_multiselect() in source:trunk/app/helpers/settings_helper.rb (like adding
a yield block returning a map of additional options ?) and probably also a bit in source:trunk/app/views/settings/_repositories.rhtml.

About the select list patch, going in the project Settings tab throws a HTTP 500 error too, still in the shellout() method this time called by hg adapter.

#16 - 2011-02-19 02:13 - Toshi MARUYAMA
| fixed in r4882.

#17 - 2011-02-21 13:34 - Etienne Massip

Both works fine now.
My remarks :
Concerning info panel :

e "SCM" title should be in lower size than section title "Information”
e column titles and column values are not well justified

You should handle checkboxes state in screen "Administration/Settings/Repositories/activated SCM" depending upon SCM availability, as stated in
my previous notes.

#18 - 2011-05-04 09:54 - Toshi MARUYAMA
- File hg.png added

- File bzr.png added

- Status changed from New to Closed

- Target version set to 1.2.0

- % Done changed from 40 to 0

- Resolution set to Fixed

| finished implementing in r5634.
Settings

Information Modules Members Versions Issue categories Wiki Repository ]

SCM |Mercurial [=]
% Command: C:\Program Files\TortoiseHg\hg.exe, Version: 1.8.1

Path to repository *

Local repository (e.qg. /hgrepo, c:\hgrepao)

Path encoding E
Default: UTF-8

Settings

Information Modules Members Versions Issue categories Wiki Repository

SCM | Bazaar (=]

@ command: bzr, Version:

Path to repository *

Commit messages E|
encoding *

#19 - 2011-05-10 15:13 - Etienne Massip

Why not do this control in SCM availability selection in Administration/Settings instead of Project settings, since the SCM list in Project settings is
already filtered depending upon this selection in Administration/Settings ?

#20 - 2011-05-10 15:53 - Toshi MARUYAMA

Etienne Massip wrote:
Why not do this control in SCM availability selection in Administration/Settings instead of Project settings, since the SCM list in Project settings is
already filtered depending upon this selection in Administration/Settings ?

Default list (exclude filesystem) is default setting.

There is no chance to check whether SCM commands are available or not.

And, it is difficult in case of machine replacing or recovering from database.

#21 - 2011-05-10 16:03 - Asher Baker

Toshi MARUYAMA wrote:
Default list (exclude filesystem) is default setting.

There is no chance to check whether SCM commands are available or not.

But the whole point of a feature request is to add a feature.
Denying it because it's not the current functionality is counter-intuitive.

#22 - 2011-05-10 18:44 - Etienne Massip

Moreover, actually, project managers who are not admins will see the command path, this is odd.

#23 - 2011-05-17 11:57 - Etienne Massip

- Status changed from Closed to Reopened
Please discuss the actual behavior.

#24 - 2011-05-17 12:21 - Toshi MARUYAMA
- Target version deleted (1.2.0)

#25 - 2011-05-19 09:53 - Etienne Massip

But you did commit some changes to trunk / 1.2, didn't you ?

#26 - 2011-05-19 11:41 - Toshi MARUYAMA
The followings are FAQ.

e TortoiseSVN does not have svn.exe
¢ /usr/local/bin/git is not PATH for web server
® hg.cmd and bzr.bat can not be used.

So, | think this feature is beneficial to administrators and project managers.

#27 - 2011-05-19 16:04 - Etienne Massip
- File scm_checkboxes_admin.PNG added

Don't get me wrong, I'd like this feature very much, but not the way it is implemented as for now :

I think that as it is the administrator's job to configure the Redmine instance, only him and no project manager should be aware of technical details
such as the path of SCM executable or the SCM command called behind the scenes.

That's the main reason why | think the SCM info you added in project settings under the SCM combo : Settings

Information | | Modules | Members | Versions | Issue categories | Wiki | Repository | ||

SCM | Mercurial [~
¥ Command: C:\Program Files\TortoiseHg\ha.exe, Version: 1.8.1
Path to repository *
Local repository (e.g. /harepo, c:\harepo)
Path encoding
Default: UTF-8

should be moved to admin settings active SCM list : scm_checkboxes_admin.PNG

#28 - 2011-05-22 20:59 - Etienne Massip

- Target version set to 1.2.0

Just to get JPL's mind about already committed changes.

#29 - 2011-05-29 09:44 - Toshi MARUYAMA
- File admin-repo.png added

| start implementing.
Settings

Projects Issue tracking Email notifications Incoming emails

Enabled 5CM

Command Version

Subversion « sun 1.6.16
Darcs o darcs 2.4.4
Mercurial " hg 1.8.2
Cvs « s 1.12.13
Bazaar o bzr 2.1.3
Git o git 1.7.3.4
Filesystem «°

Autofetch commits

Enable W5 for repository management

#30 - 2011-05-29 10:03 - Jean-Philippe Lang

It really makes more sense on the administration panel. Toshi, please update this ticket as soon as it is done, 1.2 is about to be released.

#31 - 2011-05-29 10:15 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

Repositories

It really makes more sense on the administration panel. Toshi, please update this ticket as soon as it is done, 1.2 is about to be released.

| see.

#32 - 2011-05-29 10:17 - Toshi MARUYAMA
- Resolution deleted (Fixed)

#33 - 2011-05-29 12:58 - Toshi MARUYAMA

| have committed in trunk.
Please review it.

#34 - 2011-05-29 14:00 - Jean-Philippe Lang
- Status changed from Reopened to Closed

- Resolution set to Fixed

Looks much better, thanks :-) I've just made a few Ul changes in r5960.
| think we can close it now.

#35 - 2011-05-29 14:04 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

Looks much better, thanks :-) I've just made a few Ul changes in r5960.

| think we can close it now.

Thanks, | will merge to 1.2-stable.

#36 - 2011-05-29 14:06 - Jean-Philippe Lang
Merged in 1.2-stable in r5961.

#37 - 2011-05-29 14:21 - Toshi MARUYAMA

Jean-Philippe Lang wrote:
Merged in 1.2-stable in r5961.

Thanks!!
